/*

    File: texgen.cpp

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include <windows.h>
#include <gl/gl.h>

#include "texgen.h"
#include "main.h"

#define tex_width	256
#define tex_height	256


unsigned int texture_id;

float texbuffer[tex_height][tex_width][4];

#include <math.h>

#include "fractal.h"
void GenerateTexture(void)
{
	Fractal_Create(&texbuffer[0][0][0], 0,1,tex_width, tex_height, sizeof(float) * 4, 1);
	Fractal_Create(&texbuffer[0][0][1], 0,1,tex_width, tex_height, sizeof(float) * 4, 1);
	Fractal_Create(&texbuffer[0][0][2], 0,1,tex_width, tex_height, sizeof(float) * 4, 1);
	Fractal_Create(&texbuffer[0][0][3], 0,1,tex_width, tex_height, sizeof(float) * 4, 1);
		//and the opengl stuff

	glEnable(GL_TEXTURE_2D);

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	glGenTextures(1, &texture_id);

	glBindTexture(GL_TEXTURE_2D, texture_id);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	
	glTexImage2D(GL_TEXTURE_2D, 0, 4, tex_width, tex_height, 0, GL_RGBA, GL_FLOAT, texbuffer);

	glDisable(GL_TEXTURE_2D);
}